### HTTP推送

- 人脸认证通过(携带人脸图片)

    ```json
    {
        "ipAddress": "",//报警设备IPv4地址
        "ipv6Address": "fe80::a54:11ff:fe02:79f1",//报警设备IPv6地址
        "portNo": 8888,//报警设备端口号
        "protocol": "HTTP",//传输通信协议类型
        "macAddress": "08:54:11:02:79:f1",//MAC地址
        "channelID": 1,//触发报警的设备通道号
        "dateTime": "2023-09-15T15:25:12+08:00",//报警时间
        "activePostCount": 1,//同一个报警已经上传的次数
        "eventType": "AccessControllerEvent",//事件类型 AccessControllerEvent-门禁事件上传报警
        "eventState": "active",//事件状态[active#有效事件,inactive#无效事件]
        "eventDescription": "Access Controller Event",//事件描述
        "deviceID": "123456",//设备ID
        "AccessControllerEvent": {
            "deviceName": "Access Controller",//设备名称
            "majorEventType": 5,//报警主类型
            "subEventType": 75,//报警次类型
            "cardReaderKind": 1,//读卡器种类 [1#IC读卡器,2#身份证读卡器,3#二维码读卡器,4#指纹头]
            "cardReaderNo": 1,//读卡器编号
            "verifyNo": 149,//多重卡认证序号
            "employeeNoString": "3",//工号(人员ID)
            "serialNo": 856,//事件流水号
            "userType": "normal",//人员类型 [normal#普通人（主人）,visitor#来宾（访客）,blackList#黑名单人,administrators#管理员]
            "currentVerifyMode": "cardOrFace",//读卡器当前验证方式 [cardAndPw#刷卡+密码,card#刷卡,cardOrPw#刷卡或密码,fp#指纹,fpAndPw#指纹+密码,fpOrCard#指纹或刷卡,fpAndCard#指纹+刷卡,fpAndCardAndPw#指纹+刷卡+密码,faceOrFpOrCardOrPw#人脸或指纹或刷卡或密码,faceAndFp#人脸+指纹,faceAndPw#人脸+密码,faceAndCard#人脸+刷卡,face#人脸,employeeNoAndPw#工号+密码,fpOrPw#指纹或密码,employeeNoAndFp#工号+指纹,employeeNoAndFpAndPw#工号+指纹+密码,faceAndFpAndCard#人脸+指纹+刷卡,faceAndPwAndFp#人脸+密码+指纹,employeeNoAndFace#工号+人脸,faceOrfaceAndCard#人脸或人脸+刷卡,fpOrface#指纹或人脸,cardOrfaceOrPw#刷卡或人脸或密码]
            "frontSerialNo": 855,//上一条事件流水号
            "attendanceStatus": "undefined",//考勤状态 [checkIn#上班,checkOut#下班,breakOut#开始休息,breakIn#结束休息,overtimeIn#开始加班,overtimeOut#结束加班]
            "statusValue": 0,
            "mask": "no",//是否戴口罩 [unknown#未知,yes#戴口罩,no#不戴口罩]
            "helmet": "unknown",//是否戴安全帽 [unknown#未知,yes#戴安全帽,no#不戴安全帽]
            "picturesNumber": 1,//图片数量
            "purePwdVerifyEnable": true,//是否支持纯密码开门
            "FaceRect": {
                "height": 0.165000,
                "width": 0.253000,
                "x": 0.744000,
                "y": 0.420000
            }
        }
    }
    ```

- 人脸认证失败(携带人脸图片)

    ```json
    {
        "ipAddress": "",
        "ipv6Address": "fe80::a54:11ff:fe02:79f1",
        "portNo": 8888,
        "protocol": "HTTP",
        "macAddress": "08:54:11:02:79:f1",
        "channelID": 1,
        "dateTime": "2023-09-15T16:22:31+08:00",
        "activePostCount": 1,
        "eventType": "AccessControllerEvent",
        "eventState": "active",
        "eventDescription": "Access Controller Event",
        "deviceID": "123456",
        "AccessControllerEvent": {
            "deviceName": "Access Controller",
            "majorEventType": 5,
            "subEventType": 76,
            "cardReaderKind": 1,
            "cardReaderNo": 1,
            "verifyNo": 136,
            "serialNo": 864,
            "currentVerifyMode": "cardOrFace",
            "frontSerialNo": 863,
            "attendanceStatus": "undefined",
            "statusValue": 0,
            "mask": "no",
            "helmet": "unknown",
            "picturesNumber": 1,
            "purePwdVerifyEnable": true,
            "FaceRect": {
                "height": 0.201000,
                "width": 0.358000,
                "x": 0.200000,
                "y": 0.281000
            }
        }
    }
    ```

- 门锁打开

    ```json
    {
        "ipAddress": "",
        "ipv6Address": "fe80::a54:11ff:fe02:79f1",
        "portNo": 8888,
        "protocol": "HTTP",
        "macAddress": "08:54:11:02:79:f1",
        "channelID": 1,
        "dateTime": "2023-09-15T15:25:12+08:00",
        "activePostCount": 1,
        "eventType": "AccessControllerEvent",
        "eventState": "active",
        "eventDescription": "Access Controller Event",
        "deviceID": "123456",
        "AccessControllerEvent": {
            "deviceName": "Access Controller",
            "majorEventType": 5,
            "subEventType": 21,
            "cardReaderKind": 1,
            "doorNo": 1,
            "serialNo": 857,
            "currentVerifyMode": "invalid",
            "frontSerialNo": 856,
            "attendanceStatus": "undefined",
            "statusValue": 0,
            "purePwdVerifyEnable": true
        }
}
    ```

- 门锁关闭
  
  ```json
  {
      "ipAddress": "",
      "ipv6Address": "fe80::a54:11ff:fe02:79f1",
      "portNo": 8888,
      "protocol": "HTTP",
      "macAddress": "08:54:11:02:79:f1",
      "channelID": 1,
      "dateTime": "2023-09-15T15:52:10+08:00",
      "activePostCount": 1,
      "eventType": "AccessControllerEvent",
      "eventState": "active",
      "eventDescription": "Access Controller Event",
      "deviceID": "123456",
      "AccessControllerEvent": {
          "deviceName": "Access Controller",
          "majorEventType": 5,
          "subEventType": 22,
          "cardReaderKind": 1,
          "doorNo": 1,
          "serialNo": 861,
          "currentVerifyMode": "invalid",
          "frontSerialNo": 860,
          "attendanceStatus": "undefined",
          "statusValue": 0,
          "purePwdVerifyEnable": true
      }
  }
  ```


- 设备防拆报警
  
  ```json
  {
      "ipAddress": "",
      "ipv6Address": "fe80::a54:11ff:fe02:79f1",
      "portNo": 8888,
      "protocol": "HTTP",
      "macAddress": "08:54:11:02:79:f1",
      "channelID": 1,
      "dateTime": "2023-09-15T15:52:12+08:00",
      "activePostCount": 1,
      "eventType": "AccessControllerEvent",
      "eventState": "active",
      "eventDescription": "Access Controller Event",
      "deviceID": "123456",
      "AccessControllerEvent": {
          "deviceName": "Access Controller",
          "majorEventType": 1,
          "subEventType": 1028,
          "verifyNo": 132,
          "serialNo": 862,
          "currentVerifyMode": "invalid",
          "frontSerialNo": 861,
          "attendanceStatus": "undefined",
          "statusValue": 0,
          "purePwdVerifyEnable": true
      }
  }
  ```

- 远程登录

  ```json
  {
      "ipAddress": "",
      "ipv6Address": "fe80::a54:11ff:fe02:79f1",
      "portNo": 8888,
      "protocol": "HTTP",
      "macAddress": "08:54:11:02:79:f1",
      "channelID": 1,
      "dateTime": "2023-09-15T15:53:08+08:00",
      "activePostCount": 1,
      "eventType": "AccessControllerEvent",
      "eventState": "active",
      "eventDescription": "Access Controller Event",
      "deviceID": "123456",
      "AccessControllerEvent": {
          "deviceName": "Access Controller",
          "majorEventType": 3,
          "subEventType": 112,
          "remoteHostAddr": "192.168.2.238",
          "verifyNo": 134,
          "serialNo": 863,
          "currentVerifyMode": "invalid",
          "frontSerialNo": 862,
          "attendanceStatus": "undefined",
          "statusValue": 0,
          "purePwdVerifyEnable": true
      }
  }
  ```

- 远程重启
  
  ```json
  {
      "ipAddress": "",
      "ipv6Address": "fe80::a54:11ff:fe02:79f1",
      "portNo": 8888,
      "protocol": "HTTP",
      "macAddress": "08:54:11:02:79:f1",
      "channelID": 1,
      "dateTime": "2023-09-15T15:51:27+08:00",
      "activePostCount": 1,
      "eventType": "AccessControllerEvent",
      "eventState": "active",
      "eventDescription": "Access Controller Event",
      "deviceID": "123456",
      "AccessControllerEvent": {
          "deviceName": "Access Controller",
          "majorEventType": 3,
          "subEventType": 123,
          "verifyNo": 155,
          "serialNo": 859,
          "currentVerifyMode": "invalid",
          "frontSerialNo": 858,
          "attendanceStatus": "undefined",
          "statusValue": 0,
          "purePwdVerifyEnable": true
      }
  }
  ```

- 设备上电启动
  
  ```json
  {
      "ipAddress": "",
      "ipv6Address": "fe80::a54:11ff:fe02:79f1",
      "portNo": 8888,
      "protocol": "HTTP",
      "macAddress": "08:54:11:02:79:f1",
      "channelID": 1,
      "dateTime": "2023-09-15T15:52:10+08:00",
      "activePostCount": 1,
      "eventType": "AccessControllerEvent",
      "eventState": "active",
      "eventDescription": "Access Controller Event",
      "deviceID": "123456",
      "AccessControllerEvent": {
          "deviceName": "Access Controller",
          "majorEventType": 2,
          "subEventType": 1024,
          "verifyNo": 128,
          "serialNo": 860,
          "currentVerifyMode": "invalid",
          "frontSerialNo": 0,
          "attendanceStatus": "undefined",
          "statusValue": 0,
          "purePwdVerifyEnable": true
      }
  }
  ```

